#! /usr/bin/perl -w

#Path to the iputils ping command
#
$PING="ping";

#Default variables
#
$IP_ADDRESS = "192.168.1.1";
$PACKET_GRANULARITY = 100;
$PACKET_COUNT = 1000;
$AGENT_NAME = "\$a12";
$OUTPUT_FILE = "pdelays.tcl";
#
#

$ip = shift || $IP_ADDRESS;
$pgran = shift || $PACKET_GRANULARITY;
$pcount = shift || $PACKET_COUNT;
$agent = shift || $AGENT_NAME;
$outname = shift || $OUTPUT_FILE;

$mindata = 64; #Minimum Ethernet frame
$maxdata = 2330; #Maximum reasonable Ethernet frame:
		 #2312 bytes data in wireless frames
		 #18 bytes Ethernet frame

if ($outname) {
	open (TCL, ">$outname") || die "Error: Could not open $outname file for writing\n";

	print TCL "$agent set_packet_granularity $pgran\n";
	for ($ps = $mindata; $ps <= $maxdata; $ps = $ps + $pgran) {
		$delay = `$PING -A -c $pcount -s $ps $ip -q | grep "min\/avg\/max" | cut -d " " -f 4 | cut -d "/" -f 2`;
		$delay = $delay / 1000; #convert the value in seconds
		$strd = sprintf ("%.9f", $delay);
		print TCL "$agent set_packet_delay $ps $strd\n";
	}
	close (TCL);
}

